// partition:  a container for organizing a set of sequential integers
//             into non-overlapping groups.
// Version:    %VERSION%
// Copyright:  2013 Matthew T. Busche.
//
// This program is free software:  you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the Free
// Software Foundation, either version 3 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.
//
// You should have received a copy of the GNU General Public License along
// with this program.  If not, see <http://www.gnu.org/licenses/>.

package org.mattbusche.util.partition.examples;

import org.mattbusche.util.partition.*;

/** I extend the Group for two purposes:
 **
 **    1. to override toString() to get a slightly different print behavior; and
 **
 **    2. to make it easier to create and work with an array of Groups.
 **       (Arrays of generics are just a bit annoying in Java.)
 **/
public class CrayonStateGroup extends Group<Crayon,CrayonState> {

    public CrayonStateGroup(Domain<Crayon,CrayonState> d, CrayonState cs) {
        super(d, cs);
    }

    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append(getValue() + ":");
        for(GroupIterator<Crayon,CrayonState> i = front();
                !i.isAfterBack(); i.inc())
        {
            sb.append(" " + i.getEntry().getMember());
        }
        return sb.toString();
    }
}
